;  - 
;  (UT5USB)   2005
;e-mail: yrsaf@mail.ru
;http://begstr.narod.ru
;
;PIC16F877-X, 4 MHz, WDT ON, POR ON, XTAL HS
;
	list p=16F877
       __CONFIG 03D36H
;
#DEFINE	BANK0   BCF 0x03,5
#DEFINE	BANK1   BSF 0x03,5
;
#DEFINE	CLK PORTA,1 ;   
#DEFINE	OE  PORTA,2
#DEFINE	WE  PORTA,3
#DEFINE	SQ  PORTA,4
#DEFINE	PTT PORTA,5
;
indf	EQU	00 ;  
OPTION_reg EQU	01
stat	EQU	03
FSR	EQU	04
;
PORTA	EQU	05
PORTB	EQU	06
PORTC	EQU	07
PORTD	EQU	08
PORTE	EQU	09
;
INTCON	EQU	0B
PIR1	EQU	0C
ADRESH	EQU	1E
ADCON0	EQU	1F
;
T1CON	EQU	10
CCPR1L	EQU	15
CCPR1H	EQU	16
CCP1CON	EQU	17

;----------------------------   ---------------
	CBLOCK 0x20

count	;
count1	; 
mode	; 
counLO	;  
counMI	;  
counHI	;  
counpLO	;  
counpMI	;  
counpHI	;  

	ENDC
;
;*************************************************************
; 
W	EQU 0
F	EQU 1
C	EQU 0
Z	EQU 2
;=============================================================
	org	2100h
 DE "Firmware by Yury Safonov (UT5USB)  Kyiv 2003.  e-mail: yrsaf@mail.ru   http://begstr.narod.ru  "

;=============================================================
	org	0x00
	goto	start	;  

	org	0x04	; 
	bcf	PIR1,2 	;    CCP1

	clrwdt		; WDT

	btfsc	mode,0	; ?
	goto	play	;  

;------------------------------  ------------------------
	btfsc	counHI,2	; 256?
	retfie		; ->   


	bsf	ADCON0,2	; 

	BANK1
	clrf	PORTB
	BANK0

	movf	counLO,w ;  SRAM
	movwf	PORTC
	movf	counMI,w
	movwf	PORTD
	movf	counHI,w
	movwf	PORTE

	btfsc	ADCON0,2	; ?
	goto	$-1	; ->  
;----------------------------------------------

	movf	ADRESH,w	; 
	movwf	PORTB

	bcf	WE
	nop
	bsf	WE	;  SRAM
;
	BANK1
	movlw	0xff
	movwf	PORTB
	BANK0


	incf	counLO,f ;   1
	btfsc	stat,Z
	incf	counMI,f
	btfsc	stat,Z
	incf	counHI,f


	retfie		;  



;=========================================================
;----------------------------  ------------
play
	movf	counHI,w  ;  
	xorwf	counpHI,w ;  
	btfss	stat,Z
	goto	nocomp
;
	movf	counMI,w
	xorwf	counpMI,w
	btfss	stat,Z
	goto	nocomp
;
	movf	counLO,w
	xorwf	counpLO,w
	btfss	stat,Z
	goto	nocomp
;
	bcf	mode,0	;  ->   
	retfie		;   


nocomp
	movf	counpLO,w ;  SRAM
	movwf	PORTC
	movf	counpMI,w
	movwf	PORTD
	movf	counpHI,w
	movwf	PORTE

	bcf	OE	;  SRAM
	nop
	bsf	CLK	;  SRAM  
	nop
	bcf	CLK
	bsf	OE	;  SRAM
;.......................................................


	incf	counpLO,f ;   1
	btfsc	stat,Z
	incf	counpMI,f
	btfsc	stat,Z
	incf	counpHI,f


	retfie		;  

;=======================================================



	org	0x200
;==================================================
;***************** MAIN PROGRAM *******************
;==================================================
start
	clrf	PORTA	; 
	clrf	PORTB
	clrf	PORTC
	clrf	PORTD
	clrf	PORTE

	BANK1
	movlw	b'00010001'	; 
	movwf	PORTA

 	movlw	b'11111111'
	movwf	PORTB

	clrf	PORTC
	clrf	PORTD

	movlw	b'00000100'
	movwf	PORTE
;
	movlw	b'00001110'	;   Left justified.
	movwf	ADCON0		; 1  ,  .

	movlw	b'00101111'	;   128
	movwf	OPTION_REG	;   WDT
	BANK0

	bsf	OE	;   SRAM
	bsf	WE



	BANK1
	clrf	PORTB
	BANK0

	movlw	0x7f
	movwf	PORTB	; 

	bsf	CLK	;  
	nop
	bcf	CLK

	BANK1
	movlw	0xff
	movwf	PORTB
	BANK0


	movlw	b'00110001' ; TMR1,   . .
	movwf	T1CON	   ; 1:8
;
	movlw	b'00001011' ;  CCP1  
	movwf	CCP1CON	   ; +  TMR1

;================================================================
;  

	movlw	.32
	movwf	fsr
clera
	clrf	indf
	incf	fsr,f
	btfss	fsr,7
	goto	clera
;
;================================================================
;   (125000/n+1)

	movlw	.9	;12500
	btfss	PORTE,2
	movlw	.19	;6250
	movwf	CCPR1L
;
	movlw	.0
	movwf	CCPR1H
;
;
	movlw	b'01000000' ;  
	movwf	INTCON
	BANK1
	movlw	b'00000100' ;   CCP1
	movwf	PIR1
	BANK0


	movlw	b'01000001' ; ,  0
	movwf	ADCON0	   ;  Fosc/8


;******************************************************************
begin
	clrwdt		; WDT
	btfsc	SQ	;  squelch   
	goto	begin

	bsf	INTCON,7 ;  -  
;
SQon
	btfsc	counHI,2 ; 256? -> 
	goto	SQoff
	btfss	SQ	;   squelch   
	goto	SQon


SQoff
	bcf	INTCON,7	;  -  

;-----------------------    ---------------

	movf	counHI,w	;   
	btfss	stat,Z	;?
	goto	movie	; ->   
;

	movlw	.12	;(256*n) / 12500 = ~246 mS
	subwf	counMI,w	;   
	btfsc	stat,c	;?
	goto	movie	; ->   
;
	clrf	counLO	;   
	clrf	counMI
	clrf	counHI
	goto	begin	;  



;===============================================================
movie
	bsf	PTT	;  PTT  
;
;
	movlw	.255	; 
	movwf	count1	;(3uS * 255) * 255 = ~195 mS
;
	decfsz	count,f
	goto	$-1
	decfsz	count1,f
	goto	$-3
;
;
	bsf	mode,0	;   

	clrf	counpLO	;  
	clrf	counpMI
	clrf	counpHI

	bsf	INTCON,7	;  -  

	btfsc	mode,0	;  ?
	goto	$-1	; ->  


	bcf	INTCON,7	;  -  
	bcf	PTT	;  PTT  

	clrf	counLO	;  
	clrf	counMI
	clrf	counHI


	goto	begin	;  


	end